#!/bin/csh -f
# Script to run the program unresCSA on linux with MPICH/PBS (parallel version).
#

set ROOT = /users/adam/MEY_MD/4Pawel/
set DD = ${ROOT}/PARAM
set BIN = ${ROOT}/bin

setenv POT GB
setenv PREFIX proteinA_8_8_ene

# 5/17/97 parameter file assignment was changed from link to SETENV statements
#
setenv BONDPAR ${DD}/bond.parm
setenv THETPAR $DD/thetaml.5parm
setenv ROTPAR $DD/scgauss.parm
setenv TORPAR $DD/torsion_631Gdp.parm
setenv TORDPAR $DD/torsion_double_631Gdp.parm
setenv ELEPAR $DD/electr_631Gdp.parm
setenv SIDEPAR  $DD/sc_GB_opt.1igd_hnc_iter8scsc_8nn1
setenv FOURIER $DD/fourier_opt.parm.1igd_hc_iter3_3
setenv SCPPAR $DD/scp.parm

# Pattern database
setenv PATTERN $DD/patterns.cart
echo "setenv PATTERN $DD/patterns.cart " 

# Set parallel environment, depending on job type (interactive or batch).

set DEBUG = 0

$BIN/unresMD_procor.exe $*

if ("$3" != "-p4amslave") then
# Remove links
/bin/rm fort.*
# Clear empty files
find . -size 0 -exec rm {} \;
endif
